<?xml version="1.0" encoding="iso-8859-1"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" id="stylesheet" version="1.0">
    <xsl:template match="xsl:stylesheet"/>
    <xsl:output method="html"/>
    <xsl:template match="/">
    <html>
		<meta charset="utf-8" />
		<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
		<head>
            <title>Family Tree of Blood and Spirit</title>
            <link rel="stylesheet" type="text/css" href="print.css" media="print"/>
            <script type="text/javascript">
            <![CDATA[
            var openImg = new Image();
            openImg.src = "open.gif";
            var closedImg = new Image();
            closedImg.src = "closed.gif";
            var flagColor="black"
            function showBranch(branch){
                    var objBranch = document.getElementById(branch).style;
                    if(objBranch.display=="block")
                     objBranch.display="none";
                    else
                     objBranch.display="block";
                    swapFolder('I' + branch);
             }
             
            function swapFolder(img){
                objBranch = document.getElementById(img).src
                    if(objBranch==closedImg.src)
                    document.getElementById(img).src= openImg.src
                    else
                            document.getElementById(img).src = closedImg.src;
              }
             
            /*could add the root element to speed it up in the getelementbytagname*/
             
            function getElementByClassClose (tagName, className) {
                var all = document.all ? document.all :
                    document.getElementsByTagName(tagName);
                for (var e = 0; e < all.length-1; e++)
                        if (all[e].className == className)
                        all[e].style.display="none";
            }
             
            function getElementByClassCloseFolder (tagName, className) {
                var all = document.all ? document.all :
                    document.getElementsByTagName(tagName);
                for (var e = 0; e < all.length-1; e++)
                        if (all[e].className == className)
                        document.getElementById(all[e].id).src = closedImg.src
            }
             
            function getElementByClassOpen (tagName, className) {
                var all = document.all ? document.all :
                    document.getElementsByTagName(tagName);
                for (var e = 0; e < all.length-1; e++)
                        if (all[e].className == className)
                        all[e].style.display="block";
            }
             
            function getElementByClassOpenFolder (tagName, className) {
                var all = document.all ? document.all :
                    document.getElementsByTagName(tagName);
                for (var e = 0; e < all.length-1; e++)
                        if (all[e].className == className)
                        document.getElementById(all[e].id).src = openImg.src
            }
             
            function toggle (tagName, classNam, str) {
                var all = document.all ? document.all :
                    document.getElementsByTagName(tagName);
                for (var e = 0; e < all.length-1; e++){
                        if (all[e].className == classNam){
                        if (all[e].style.color == str){
                        if(all[e].style.display=="none"){
                            all[e].style.display="block"
                        }else{
                        all[e].style.display="none";
                        }      
                        }
                    }
                }
            }
             
            var activecolor
             
             
            function closeMenu(){
                var men =document.getElementById("menucont");
                men.innerHTML=""
                activecolor=""
            }
                 
            function colorizeOrlink(id){
                var men =document.getElementById("menucont");  
                var item = document.getElementById(id);
                if(men.innerHTML!=""){
                    //flgClr(activecolor,id);  
                item.style.color=activecolor
                }
            }
        ]]>
        </script>
        <style>
            .trigger{
                  cursor: pointer;
                  display: table;
                  //font-weight:bold;
               }
             
            .branch{
                display: none;
                margin-left: 16px;
               }
             
            span{
                font-family: sans-serif;
                font-size: 11pt;
            }
             
             
            td{ vertical-align:top
                border: 1px groove black;
            }      
             a:link              { color:black; text-decoration:underline; cursor:pointer}
             a:visited           { color:black; text-decoration:underline; }
             a:hover             { color:black; text-decoration:underline; }
             a:active            { color:black; text-decoration:underline; }
              
            .docanchor{
                 display:block;
                 text-indent: -9px;
                 margin-left: 9px;
            }
            </style>
        </head>
        <xsl:apply-templates select="forest"/>
    </html>
</xsl:template>
<xsl:template match="forest">
    <body>
        <div id="menucont"/>
        <table>
            <span style="font:bold;">
                <strong>3d Family Tree of Blood <b><i>and</i></b> Spirit</strong>
                <br/>
                <p>These xml, xsl, css, and javascript files demonstrate the concept of a 3d/3 dimensional treeview control.</p>
                <p>Relationships between heirarchical information can be drawn in three dimensions not just two, with branches and leaves going either down or right.</p>
                <p>This functionality is achieved by, rather than following the traditional logic of parent-child, extending the concept to include parent-child-friend.</p>
                <p>To accomplisth this one need only add an attribute at each node of "direction" equaling either "right" or "down".</p>
                <p>The "practical" application of such a thing, I am not sure of.</p>
                <p>On the other hand sometimes it certainly makes you look at things a different way...</p>
                <p>
                    <strong>Enjoy!</strong>
                </p>
                <xsl:value-of select="text()"/>
            </span>
            <span onclick="getElementByClassOpen('span','branch');getElementByClassOpenFolder('img','folder');" style="=text-align:right; color:blue; cursor:pointer; width:200;">open all</span>
            <span onclick="getElementByClassClose('span','branch');getElementByClassCloseFolder('img','folder')" style="=text-align:right; color:blue; cursor:pointer; width:200;">close all</span>
            <tr>
                <xsl:apply-templates select="node">
                    <!--<xsl:sort select="self::node()[@direction]" data-type="text" order="descending"/>-->
                </xsl:apply-templates>
            </tr>
        </table>
    </body>
</xsl:template>
<xsl:template match="node">
    <xsl:for-each select="self::node()[@direction='right']">
        <td style="border: 1px groove black;vertical-align:top;">
            <xsl:variable name="secondid" select="generate-id(.)"/>
            <span class="trigger">
                <img src="closed.gif" class="folder">
                <xsl:attribute name="id">I<xsl:value-of select="generate-id(.)"/>
            </xsl:attribute>
            <xsl:if test="count(child::node())=0">
                <xsl:attribute name="src">task.gif</xsl:attribute>
            </xsl:if>
            <xsl:if test="count(child::node())!=0">
                <xsl:attribute name="onClick">
                                        showBranch('<xsl:value-of select="generate-id(.)"/>','<xsl:value-of select="$secondid"/>');
                                    </xsl:attribute>
                    </xsl:if>
                            </img>
                    <xsl:variable name="rightid" select="generate-id(.)"/>
                    <a>
                        <xsl:attribute name="id">a<xsl:value-of select="$rightid"/>
                    </xsl:attribute>
                    <xsl:if test="boolean(@a)='true'">
                        <xsl:attribute name="href">
                            <xsl:value-of select="@a"/>
                        </xsl:attribute>
                    </xsl:if>
                    <xsl:attribute name="onClick">
                                            colorizeOrlink(this.id);
                                        </xsl:attribute>
                        <xsl:value-of select="@name"/>
                    </a>
                </span>
            </td>
            <td style="vertical-align:top;">
                <span class="branch">
                    <xsl:attribute name="id">
                        <xsl:value-of select="generate-id(.)"/>
                    </xsl:attribute>
                    <xsl:variable name="countps" select="number(count(node[@direction='right']))"/>
                    <xsl:apply-templates select="node">
                    </xsl:apply-templates>
                </span>
            </td>
        </xsl:for-each>
        <xsl:for-each select="self::node()[@direction='down']">
            <tr>
                <td style="vertical-align:top;">
                    <xsl:variable name="sid" select="generate-id(.)"/>
                    <span class="trigger">
                        <img src="closed.gif" class="folder">
                        <xsl:attribute name="id">I<xsl:value-of select="generate-id(.)"/>
                    </xsl:attribute>
                    <xsl:if test="count(child::node())=0">
                        <xsl:attribute name="src">task.gif</xsl:attribute>
                    </xsl:if>
                    <xsl:if test="count(child::node())!=0">
                        <xsl:attribute name="onClick">showBranch('<xsl:value-of select="generate-id(.)"/>','<xsl:value-of select="$sid"/>');</xsl:attribute>
                        </xsl:if>
                    </img>
                    <xsl:variable name="downid" select="generate-id(.)"/>
                    <a>
                        <xsl:attribute name="id">b<xsl:value-of select="$downid"/>
                    </xsl:attribute>
                    <xsl:if test="boolean(@a)='true'">
                        <xsl:attribute name="href">
                            <xsl:value-of select="@a"/>
                        </xsl:attribute>
                    </xsl:if>
                    <xsl:attribute name="onClick">colorizeOrlink(this.id);</xsl:attribute>
                        <xsl:value-of select="@name"/>
                    </a>
                </span>
            </td>
            <td style="vertical-align:top;">
                <table>
                    <span class="branch">
                        <xsl:attribute name="id">
                            <xsl:value-of select="generate-id(.)"/>
                        </xsl:attribute>
                        <xsl:variable name="countps" select="number(count(node[@direction='right']))"/>
                        <xsl:apply-templates select="node">
                            <!-- <xsl:sort select="self::node()[@direction]" data-type="text" order="descending"/>-->
                        </xsl:apply-templates>
                    </span>
                </table>
            </td>
        </tr>
    </xsl:for-each>
</xsl:template>
<!-- end - rest of your stylesheet -->
</xsl:stylesheet>
